/*
 * BookEditor.java
 *
 * Created on August 9, 2008, 2:50 PM
 */

package com.smartitengineering.demo.selectionsuite.multivieweditor;
import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.adapter.BasicComponentFactory;
import com.jgoodies.binding.value.ValueHolder;
import com.jgoodies.binding.value.ValueModel;
import com.smartitengineering.demo.selectionsuite.api.book.BookNode;
import com.smartitengineering.demo.suiteselection.domain.book.Book;
import java.awt.Image;
import java.text.DecimalFormat;
import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JPanel;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewDescription;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.openide.util.HelpCtx;
import org.openide.util.Lookup;
import org.openide.util.lookup.Lookups;
import org.openide.windows.TopComponent;


/**
 *
 * @author  modhu7
 */
public class BookEditor extends javax.swing.JPanel implements MultiViewDescription, MultiViewElement{
    private PresentationModel<Book> presentationModel;
    private ValueModel nameValueModel;
    private ValueModel stockAmountValueModel;
    /** Creates new form BookEditor */
    public BookEditor() {
        initComponents();
    }
    public BookEditor(BookNode node,PresentationModel presentationModel){
        this.presentationModel = presentationModel;
        nameValueModel = presentationModel.getModel(Book.PROPERTYNAME_NAME);
        stockAmountValueModel = presentationModel.getModel(Book.PROPERTYNAME_STRING_STOCKAMOUNT);
        initComponents();
        nameTextField.setText(node.getBookName());
        //System.out.println(node.getBook().getName());
        stockAmountTextField.setText(node.getStringStockAmount());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        stockAmountTextField = BasicComponentFactory.createTextField(stockAmountValueModel);
        jButton1 = new javax.swing.JButton();

        jLabel1.setText(org.openide.util.NbBundle.getMessage(BookEditor.class, "BookEditor.jLabel1.text")); // NOI18N

        nameValueModel = presentationModel.getModel(Book.PROPERTYNAME_NAME);
        nameTextField = BasicComponentFactory.createTextField(nameValueModel);
        nameTextField.setText(org.openide.util.NbBundle.getMessage(BookEditor.class, "BookEditor.nameTextField.text")); // NOI18N

        jLabel2.setText(org.openide.util.NbBundle.getMessage(BookEditor.class, "BookEditor.jLabel2.text")); // NOI18N

        stockAmountTextField.setText(org.openide.util.NbBundle.getMessage(BookEditor.class, "BookEditor.stockAmountTextField.text")); // NOI18N
        stockAmountTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stockAmountTextFieldActionPerformed(evt);
            }
        });

        jButton1.setText(org.openide.util.NbBundle.getMessage(BookEditor.class, "BookEditor.jButton1.text")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(79, 79, 79)
                        .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 199, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(stockAmountTextField))))
                .addContainerGap(133, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(stockAmountTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(55, 55, 55)
                .addComponent(jButton1)
                .addContainerGap(120, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

private void stockAmountTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stockAmountTextFieldActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_stockAmountTextFieldActionPerformed

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    
}//GEN-LAST:event_jButton1ActionPerformed

    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    public String getDisplayName() {
        return "Editor";
    }

    public Image getIcon() {
        return null;
    }

    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }

    public String preferredID() {
        return "BookEditor";
    }

    public MultiViewElement createElement() {
        return this;
    }

    public JComponent getVisualRepresentation() {
        return this;
    }

    public JComponent getToolbarRepresentation() {
        return new JPanel();
    }

    public Action[] getActions() {
        return null;
    }

    public Lookup getLookup() {
        Lookup lookup = Lookups.singleton(this);
        return lookup;
    }

    public void componentOpened() {
        
    }

    public void componentClosed() {
        
    }

    public void componentShowing() {
        
    }

    public void componentHidden() {
        
    }

    public void componentActivated() {
        
    }

    public void componentDeactivated() {
        
    }

    public UndoRedo getUndoRedo() {
        return null;
    }

    public void setMultiViewCallback(MultiViewElementCallback arg0) {
        
    }

    public CloseOperationState canCloseElement() {
        return CloseOperationState.STATE_OK;
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JTextField stockAmountTextField;
    // End of variables declaration//GEN-END:variables

}
